/*
 * $Id: heap.h 3 2005-12-27 20:54:46Z nangel $
 * 
 */
#ifndef X_HEAP_H
#define X_HEAP_H	1


/* heap type */
typedef struct {
	size_t	capacity;	/* the total capacity of the heap */
	size_t	size;		/* the current size of the heap	  */
	int	(*compare) (void *, void *);	/* pointer to a compare function  */
	void 	**element;	/* will be a pointer to an array  */
	} heap_t;


/* heap.c */
int _heapElementCompare(void *a, void *b);
heap_t *heapInitialize(void *fn);
void heapFree(heap_t *h);
void *heapRemove(heap_t *h);
void *heapInsert(heap_t *h, void *data, size_t size);


#endif /* !X_HEAP_H */
